#include<stdio.h>
#include"tab.h"


/* Funkcja wczytuje  ze standardowego wejscia (z klawiatury) liczby rzeczywiste do tablicy 't[]'.
 * Argument 'n' okresla liczbe wczytywanych wartosci.
 * Wartoscia zwracana jest liczba wczytanych liczb' */
void wczytaj(float t[],int n)
{
	int i;
	for(i=0;i<n;i++)
	{
		printf("t[%i]=",i);
		scanf("%f",&t[i]);
	}
}

/*  Funkcja odwraca elemnty w tablicy t[]. Argument 'n' okresla liczbe elementow w tablicy (tylko pierwsze 'n' elementow ulegnie odwroceniu). 
 *  Wartoscia zwracana jest adres tablicy z odwrocona zawartoscia. */
float *odwroc(float *t,int n)
{
   float *k=t+n-1;
   float *p=t;
   float tmp;

   while(k>p)
   {
      zamien(p,k);
      k--;
      p++;
   }
   return t;
}


/* Funkcja wyswietla na ekranie 'n' pierwszych liczb rzeczywistych zawartych w tablicy 't[]' */
void wyswietl(float t[],int n)
{
	int i=0;
	printf("Zawartosc tablicy (ilosc elementow=%d)\n",n);
	while(i<n) printf("t[%i]=%f\n",i,t[i++]);

}

/* Funkcja oblicza sume elementow tablicy (sume 'n' pierwszych liczb umieszczonych w tablicy 't[]').  */
float suma(float t[],int n)
{
	float s=0;
	while(n>0) s+=t[--n];
	return s;
}


/* Funkcja oblicza wartosc srednia z 'n' pierwszych liczb umieszczonych w tablicy 't[]'.  */
float srednia(float t[],int n)
{
	return suma(t,n)/n;

}

/* Funckja znajduje w tablicy 'tab[]' element o najwiekszej wartosci.
 * Wartoscia zwracana jest pozycja elementu o najwiekszej wartosci.   */
int maxind(float tab[],int n)
{
	int m=0,i;

   for(i=0;i<n;i++)  if(tab[m]<tab[i]) m=i;
	return m;
}

/* Funckja znajduje w tablicy 'tab[]' element o najwiekszej wartosci.
 * Wartoscia zwracana jest element tabicy o najwiekszej wartosci.   */
float maksimum(float t[],int n)
{
	return t[maxind(t,n)];
}

/* Funcka sortuje ementy tablicy 't[]' za pomoca algorytmu babelkowego.
 * Argument 'n' reprezentuje liczbe elementow w tablicy.
 * Wartoscia zwracana jest wskaznik do posortowanej tablicy. */
void sortuj(float t[],int n)
{
   float tmp;
   int m;

   while(n>0)
   {
      m=maxind(t,n);
      zamien(t+m,t+n-1);
      n--;
   }
}

void zamien(float *a,float *b)
{
   float t=*a;
   *a=*b;
   *b=t;
}

